/**
 * Copyright (c) 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.admin.jmx;

import org.ow2.petals.admin.api.ArtifactAdministration;
import org.ow2.petals.admin.api.ContainerAdministration;
import org.ow2.petals.admin.api.EndpointDirectoryAdministration;
import org.ow2.petals.admin.api.PetalsAdministration;
import org.ow2.petals.admin.api.artifact.lifecycle.ArtifactLifecycleFactory;
import org.ow2.petals.admin.api.conf.PetalsAdminConfiguration;
import org.ow2.petals.admin.jmx.artifact.JMXArtifactLifecycleFactory;

public class JMXPetalsAdministration implements PetalsAdministration {

    private final PetalsAdminConfiguration configuration;

    public JMXPetalsAdministration(final PetalsAdminConfiguration config) {
        this.configuration = config;
    }

    @Override
    public ArtifactAdministration newArtifactAdministration() {
        return new JMXArtifactAdministration(this.newArtifactLifecycleFactory(), this.configuration);
    }

    @Override
    public ContainerAdministration newContainerAdministration() {
        return new JMXContainerAdministration(this.newArtifactAdministration());
    }

    @Override
    public EndpointDirectoryAdministration newEndpointDirectoryAdministration() {
        return new JMXEndpointDirectoryAdministration();
    }

    @Override
    public ArtifactLifecycleFactory newArtifactLifecycleFactory() {
        return new JMXArtifactLifecycleFactory(this.configuration);
    }

}
